#define SAA7111A_ADR (0x48)

int SAA7111A_check(void *priv) { // 0001.5eb2

	return I2CReadDevice(priv,SAA7111A_ADR,0x00)==-1;
}

int SAA7111A_setreg(void *priv,int reg,int val) { // 0001.5eda

	return I2CWriteDevice(priv,SAA7111A_ADR,reg,val);
}

int SAA7111A_getreg(void *priv,int reg) { // 0001.5f10

	return I2CReadDevice(priv,SAA7111A_ADR,reg);
}

int SAA7111A_disable(void *priv) { // 0001.6824

	return SAA7111A_setreg(priv,0x11,0x00);
}

void SAA7111A_basic(void *priv) {	//0001.75de

	SAA7111A_setreg(priv,0x02,0xd1/*(SAA7111A_getreg(0x02)&~4)|3*/ );	/* CVBS signal from AI22 */
}

void SAA7111A_imgctrl(void *priv,int bright,int contr,int satur,int hue,int sharp) {	//0001.75f6

	SAA7111A_setreg(priv,0x0a,bright);	/* Brightness */
	SAA7111A_setreg(priv,0x0b,contr );	/* Contrast  */
	SAA7111A_setreg(priv,0x0c,satur );	/* Saturation */
	SAA7111A_setreg(priv,0x0d,hue   );	/* Hue        */
	SAA7111A_setreg(priv,0x09,(SAA7111A_getreg(priv,0x09)&~0x33)|(sharp&0x33) );	/* Filters for sharpness */
}

void SAA7111A_imgctrl_zero(void *priv) {	//0001.67ea
	SAA7111A_imgctrl(priv,0,0,0,0,0);
}

void SAA7111A_setup1(void *priv) {	//0001.5f22
	SAA7111A_setreg(priv,0x00,0x00);
	SAA7111A_setreg(priv,0x02,0xd1);
	SAA7111A_setreg(priv,0x03,0x00);
	SAA7111A_setreg(priv,0x04,0x00);
	SAA7111A_setreg(priv,0x05,0x00);
	SAA7111A_setreg(priv,0x06,0xf9);
	SAA7111A_setreg(priv,0x07,0xe9);
	SAA7111A_setreg(priv,0x08,0x0d);
	SAA7111A_setreg(priv,0x09,0x00);
	SAA7111A_setreg(priv,0x0a,0x00);
	SAA7111A_setreg(priv,0x0b,0x00);
	SAA7111A_setreg(priv,0x0c,0x00);
	SAA7111A_setreg(priv,0x0d,0x00);
	SAA7111A_setreg(priv,0x0e,0x00);
	SAA7111A_setreg(priv,0x0f,0x00);
	SAA7111A_setreg(priv,0x10,0xd0);
	SAA7111A_setreg(priv,0x11,0x0c);
	SAA7111A_setreg(priv,0x12,0x01);
	SAA7111A_setreg(priv,0x13,0x00);
}

void SAA7111A_setup2(void *priv) {	//0001.603a
	SAA7111A_setreg(priv,0x00,0x00);
	SAA7111A_setreg(priv,0x02,0xd4);
	SAA7111A_setreg(priv,0x03,0x00);
	SAA7111A_setreg(priv,0x04,0x00);
	SAA7111A_setreg(priv,0x05,0x00);
	SAA7111A_setreg(priv,0x06,0xf9);
	SAA7111A_setreg(priv,0x07,0xe9);
	SAA7111A_setreg(priv,0x08,0x0d);
	SAA7111A_setreg(priv,0x09,0x80);
	SAA7111A_setreg(priv,0x0a,0x00);
	SAA7111A_setreg(priv,0x0b,0x00);
	SAA7111A_setreg(priv,0x0c,0x00);
	SAA7111A_setreg(priv,0x0d,0x00);
	SAA7111A_setreg(priv,0x0e,0x00);
	SAA7111A_setreg(priv,0x0f,0x00);
	SAA7111A_setreg(priv,0x10,0xd0);
	SAA7111A_setreg(priv,0x11,0x0c);
	SAA7111A_setreg(priv,0x12,0x01);
	SAA7111A_setreg(priv,0x13,0x00);
}
